#include "Qt2DGraphiX.h"

int update();
void load();

Qt2DGraphiX::Image2D img;
int width=640,height=480;

int main(int argc, char *argv[])
{
    return Qt2DGraphiX::init(argc,argv,load,update,"My Qt2DGraphiX Sample");
}

void load()
{
    img=Qt2DGraphiX::loadImage("../../../tick.png");
    if (!Qt2DGraphiX::isImage(img))
        img=Qt2DGraphiX::loadImage("../tick.png");
}

int update()
{
    //clear
    Qt2DGraphiX::fillRectangle(0,0,width,height,0xFFFFFF);


    //time management in miliseconds
    static int t=Qt2DGraphiX::getTime();
    int deltaTime=Qt2DGraphiX::getTime()-t;
    t=Qt2DGraphiX::getTime();
    qDebug()<<"Delta time : "<<deltaTime;

    if (Qt2DGraphiX::getFrameCount()<5) Qt2DGraphiX::drawImage(50,50,img);

    //dot above the line
    static Qt2DGraphiX::Vector2D p(1,1),v(1,1);
    Qt2DGraphiX::putPixel(p,0x000000);
    p+=v;
    if (p.x()>=width || p.x()<0)
        v.setX(-v.x());
    if (p.y()>=100 || p.y()<0)
        v.setY(-v.y());
    if (v.lengthSquared()<16) v*=1.002;

    //the line!
    Qt2DGraphiX::drawLine(0,100,width,100,0);

    //dots behind the line!
    static Qt2DGraphiX::Vector2D p2[10],v2[10];
    static bool flag=false;
    static int color2[10];
    if (!flag) for (int i=0;i<10;++i)
    {
        flag=true;
        p2[i]=Qt2DGraphiX::Vector2D(qrand()%width,qrand()%(height-100)+100);
        v2[i]=Qt2DGraphiX::Vector2D((qrand()%100)/50.0-1,(qrand()%100)/50.0-1);
        color2[i]=qrand();
    }

    for (int i=0;i<10;++i)
    {
        p2[i]+=v2[i];
        if (v2[i].lengthSquared()<10) v2[i]*=1.001;
        if (p2[i].x()>=width || p2[i].x()<0)
            v2[i].setX(-v2[i].x());
        if (p2[i].y()>=height || p2[i].y()<=100)
            v2[i].setY(-v2[i].y());
        for (int j=0;j<i;++j)
        {
            if ((p2[i]-p2[j]).lengthSquared()<3)
            {
                v2[i]=-v2[i];
                v2[j]=-v2[j];
            }
        }

        Qt2DGraphiX::putPixel(p2[i],color2[i]);
    }


    //mouse
    Qt2DGraphiX::Vector2D mp=Qt2DGraphiX::getMouseCoords();
    Qt2DGraphiX::drawCircle(mp.x(),mp.y(),5,0xFF);

    if (Qt2DGraphiX::getMouseDownButton()==Qt2DGraphiX::LeftRight)
        qDebug()<<"Down"<<(Qt2DGraphiX::getMouseDownButton());

    Qt2DGraphiX::putText(10,10,"Welcome to my program!",0);
    Qt2DGraphiX::fillRectangle(10,10, 100,100 , 0xFF0000); //normal red line
    static float r=0;
    r+=.1;
    Qt2DGraphiX::setTransform(200,200, r, 1.5, .5); //transform matrix
    Qt2DGraphiX::fillRectangle(00,0, 100,100 , 0x0000FF); //transformed green line with same coords

    return 0;
}
